﻿using System.Collections;
using UnityEngine;

namespace Mod
{
    public class EMP4 : MonoBehaviour
    {
        private GameObject gameobjectStick;

        public Vector2 ChainConnector = new Vector2(0f, 0f);
        public Vector2 rodConnector = new Vector2(0f, 0.2f);

        Sprite Human;
        private void Awake()
        {
            var mace = ModAPI.CreatePhysicalObject("Human", ModAPI.LoadSprite("SpineEnd.png"));
            mace.transform.SetParent(gameObject.transform);
            mace.AddComponent<EMP5>();
           //mace.gameObject.GetComponent<SpriteRenderer>().material = ModAPI.FindMaterial("VeryBright");
           mace.gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.001f;
            mace.transform.localPosition = new Vector3(ChainConnector.x + -0.01f, ChainConnector.y + -0.005f);
            var eye = ModAPI.CreateLight(mace.transform, new Color(1f, 0f, 1f), 2f, 2f);
            mace.gameObject.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Glass");
            eye.transform.localPosition = new Vector3(0f, 0f, 0f);
            mace.FixColliders();

            DistanceJoint2D joint = gameObject.AddComponent<DistanceJoint2D>();
            joint.maxDistanceOnly = false;
            joint.enableCollision = true;
            joint.distance = 0f;
            joint.autoConfigureDistance = true;
            joint.breakForce = Mathf.Infinity;
            joint.breakTorque = Mathf.Infinity;
            joint.anchor = ChainConnector;
            joint.connectedBody = mace.GetComponent<Rigidbody2D>();
            joint.connectedAnchor = rodConnector;
            JointCreated(joint);
        }

        void JointCreated(DistanceJoint2D joint)
        {
            EnergyWireBehaviour energyWireBehaviour = joint.gameObject.AddComponent<EnergyWireBehaviour>();
            energyWireBehaviour.WireWidth = 0.0001f;
            energyWireBehaviour.typedJoint = joint;
            energyWireBehaviour.WireMaterial = Resources.Load<Material>("Materials/Bandage");

            
        }
    }
}